diff --git a/src/bin/pg_checksums/t/002_actions.pl b/src/bin/pg_checksums/t/002_actions.pl
index 4e4934532a..35f484ee2f 100644
--- a/src/bin/pg_checksums/t/002_actions.pl
+++ b/src/bin/pg_checksums/t/002_actions.pl
@@ -5,7 +5,7 @@ use strict;
 use warnings;
 use PostgresNode;
 use TestLib;
-use Test::More tests => 63;
+use Test::More tests => 79;
 
 
 # Utility routine to create and check a table with corrupted checksums
@@ -86,6 +86,84 @@ sub check_relation_corruption
 	return;
 }
 
+# Utility routine to create and check a compressed table with corrupted checksums
+# on a wanted tablespace.  Note that this stops and starts the node
+# multiple times to perform the checks, leaving the node started
+# at the end.
+sub check_compressed_relation_corruption
+{
+	my $node       = shift;
+	my $table      = shift;
+	my $tablespace = shift;
+	my $pgdata     = $node->data_dir;
+
+	$node->safe_psql(
+		'postgres',
+		"CREATE TABLE $table (a int) WITH(compresstype=pglz, autovacuum_enabled=false);
+		 INSERT INTO $table SELECT a FROM generate_series(1,10000)a;");
+
+	$node->safe_psql('postgres',
+		"ALTER TABLE " . $table . " SET TABLESPACE " . $tablespace . ";");
+
+	my $file_corrupted =
+	  $node->safe_psql('postgres', "SELECT pg_relation_filepath('$table');") . "_pcd";
+	my $relfilenode_corrupted = $node->safe_psql('postgres',
+		"SELECT relfilenode FROM pg_class WHERE relname = '$table';");
+
+	# Set page header and block size
+	my $pageheader_size = 24;
+	my $block_size = $node->safe_psql('postgres', 'SHOW block_size;');
+	$node->stop;
+
+	# Checksums are correct for single relfilenode as the table is not
+	# corrupted yet.
+	command_ok(
+		[
+			'pg_checksums', '--check',
+			'-D',           $pgdata,
+			'--filenode',   $relfilenode_corrupted
+		],
+		"succeeds for single relfilenode on tablespace $tablespace with offline cluster"
+	);
+
+	# Time to create some corruption
+	open my $file, '+<', "$pgdata/$file_corrupted";
+	seek($file, $pageheader_size, 0);
+	syswrite($file, "\0\0\0\0\0\0\0\0\0");
+	close $file;
+
+	# Checksum checks on single relfilenode fail
+	$node->command_checks_all(
+		[
+			'pg_checksums', '--check',
+			'-D',           $pgdata,
+			'--filenode',   $relfilenode_corrupted
+		],
+		1,
+		[qr/Bad checksums:.*1/],
+		[qr/could not decompress block/],
+		"fails with corrupted data for single relfilenode on tablespace $tablespace"
+	);
+
+	# Global checksum checks fail as well
+	$node->command_checks_all(
+		[ 'pg_checksums', '--check', '-D', $pgdata ],
+		1,
+		[qr/Bad checksums:.*1/],
+		[qr/could not decompress block/],
+		"fails with corrupted data on tablespace $tablespace");
+
+	# Drop corrupted table again and make sure there is no more corruption.
+	$node->start;
+	$node->safe_psql('postgres', "DROP TABLE $table;");
+	$node->stop;
+	$node->command_ok([ 'pg_checksums', '--check', '-D', $pgdata ],
+		"succeeds again after table drop on tablespace $tablespace");
+
+	$node->start;
+	return;
+}
+
 # Initialize node with checksums disabled.
 my $node = get_new_node('node_checksum');
 $node->init();
@@ -115,6 +193,15 @@ append_to_file "$pgdata/global/pgsql_tmp/1.1",        "foo";
 append_to_file "$pgdata/global/pg_internal.init",     "foo";
 append_to_file "$pgdata/global/pg_internal.init.123", "foo";
 
+# Create a compressed table and index before vertify enable checksums
+$node->start;
+$node->safe_psql(
+	'postgres',
+	"CREATE TABLE compressed_table(a int) WITH(compresstype=pglz, autovacuum_enabled=false);
+	 INSERT INTO compressed_table SELECT a FROM generate_series(1,10000)a;
+	 CREATE INDEX ON compressed_table(a) WITH(compresstype=pglz);");
+$node->stop;
+
 # Enable checksums.
 command_ok([ 'pg_checksums', '--enable', '--no-sync', '-D', $pgdata ],
 	"checksums successfully enabled in cluster");
@@ -180,6 +267,7 @@ command_fails([ 'pg_checksums', '--check', '-D', $pgdata ],
 
 # Check corruption of table on default tablespace.
 check_relation_corruption($node, 'corrupt1', 'pg_default');
+check_compressed_relation_corruption($node, 'compressed_corrupt1', 'pg_default');
 
 # Create tablespace to check corruptions in a non-default tablespace.
 my $basedir        = $node->basedir;
@@ -189,6 +277,7 @@ $tablespace_dir = TestLib::perl2host($tablespace_dir);
 $node->safe_psql('postgres',
 	"CREATE TABLESPACE ts_corrupt LOCATION '$tablespace_dir';");
 check_relation_corruption($node, 'corrupt2', 'ts_corrupt');
+check_compressed_relation_corruption($node, 'compressed_corrupt2', 'ts_corrupt');
 
 # Utility routine to check that pg_checksums is able to detect
 # correctly-named relation files filled with some corrupted data.
diff --git a/src/bin/pg_rewind/copy_fetch.c b/src/bin/pg_rewind/copy_fetch.c
index 1edab5f186..cb95088045 100644
--- a/src/bin/pg_rewind/copy_fetch.c
+++ b/src/bin/pg_rewind/copy_fetch.c
@@ -14,17 +14,24 @@
 #include <fcntl.h>
 #include <unistd.h>
 
+#include "common/string.h"
 #include "datapagemap.h"
 #include "fetch.h"
 #include "file_ops.h"
 #include "filemap.h"
 #include "pg_rewind.h"
+#include "storage/page_compression.h"
 
 static void recurse_dir(const char *datadir, const char *path,
 						process_file_callback_t callback);
 
-static void execute_pagemap(datapagemap_t *pagemap, const char *path);
-
+static void execute_pagemap(datapagemap_t *pagemap, const char *path,
+							bool iscompressedrel, int chunk_size,
+							int prealloc_chunks, compressedpagemap_t *first_compressedpagemap);
+static void rewind_copy_compressed_relation_range(const char *path, int chunk_size, 
+												  BlockNumber blocknum, int nblocks,
+												  int prealloc_chunks,
+												  compressedpagemap_t *first_compressedpagemap);
 /*
  * Traverse through all files in a data directory, calling 'callback'
  * for each file.
@@ -95,10 +102,32 @@ recurse_dir(const char *datadir, const char *parentpath,
 			snprintf(path, sizeof(path), "%s", xlde->d_name);
 
 		if (S_ISREG(fst.st_mode))
-			callback(path, FILE_TYPE_REGULAR, fst.st_size, NULL);
+		{
+			if(pg_str_endswith(path, "_pca"))
+			{			
+				int					fd, ret;
+				PageCompressHeader	pchdr;
+
+				/* read header of compressed relation address file */
+				fd = open(fullpath, O_RDONLY | PG_BINARY, 0);
+				if (fd < 0)
+					pg_fatal("could not open file \"%s\": %m",
+							fullpath);
+
+				ret = read(fd, &pchdr, sizeof(PageCompressHeader));
+				if(ret == sizeof(PageCompressHeader))
+					callback(path, FILE_TYPE_REGULAR, fst.st_size, NULL, &pchdr);
+				else
+					callback(path, FILE_TYPE_REGULAR, fst.st_size, NULL, NULL);
+
+				close(fd);
+			}
+			else
+				callback(path, FILE_TYPE_REGULAR, fst.st_size, NULL, NULL);
+		}
 		else if (S_ISDIR(fst.st_mode))
 		{
-			callback(path, FILE_TYPE_DIRECTORY, 0, NULL);
+			callback(path, FILE_TYPE_DIRECTORY, 0, NULL, NULL);
 			/* recurse to handle subdirectories */
 			recurse_dir(datadir, path, callback);
 		}
@@ -121,7 +150,7 @@ recurse_dir(const char *datadir, const char *parentpath,
 						 fullpath);
 			link_target[len] = '\0';
 
-			callback(path, FILE_TYPE_SYMLINK, 0, link_target);
+			callback(path, FILE_TYPE_SYMLINK, 0, link_target, NULL);
 
 			/*
 			 * If it's a symlink within pg_tblspc, we need to recurse into it,
@@ -147,6 +176,46 @@ recurse_dir(const char *datadir, const char *parentpath,
 				 fullparentpath);
 }
 
+void
+local_fetchCompressedRelationAddress(filemap_t *map)
+{
+	char		srcpath[MAXPGPATH];
+	file_entry_t *entry;
+	int			chunk_size;
+	int			fd, i;
+	PageCompressHeader	*pcMap;
+
+	for (i = 0; i < map->narray; i++)
+	{
+		entry = map->array[i];
+
+		if(entry->type != FILE_TYPE_COMPRESSED_REL)
+			continue;
+
+		chunk_size = entry->chunk_size;
+
+		/* read page compression file header of source relation */
+		snprintf(srcpath, sizeof(srcpath), "%s/%s", datadir_source, entry->pca->path);
+		fd = open(srcpath, O_RDONLY | PG_BINARY, 0);
+		if (fd < 0)
+			pg_fatal("could not open source file \"%s\": %m",
+					srcpath);
+
+		pcMap = pc_mmap(fd, chunk_size, true);
+		if(pcMap == MAP_FAILED)
+			pg_fatal("Failed to mmap page compression address file %s: %m",
+					srcpath);
+
+		if (close(fd) != 0)
+			pg_fatal("could not close file \"%s\": %m", srcpath);
+		
+		fill_compressed_relation_address(entry, NULL, pcMap);
+
+		if (pc_munmap(pcMap) != 0)
+			pg_fatal("could not munmap file \"%s\": %m", srcpath);
+	}
+}
+
 /*
  * Copy a file from source to target, between 'begin' and 'end' offsets.
  *
@@ -197,6 +266,89 @@ rewind_copy_file_range(const char *path, off_t begin, off_t end, bool trunc)
 		pg_fatal("could not close file \"%s\": %m", srcpath);
 }
 
+/*
+ * Copy a file from source to target, between 'begin' and 'end' offsets.
+ *
+ * If 'trunc' is true, any existing file with the same name is truncated.
+ */
+static void 
+rewind_copy_compressed_relation_range(const char *path, int chunk_size, 
+									  BlockNumber blocknum, int nblocks,
+									  int prealloc_chunks,
+									  compressedpagemap_t *first_compressedpagemap)
+{
+	PGAlignedBlock buf;
+	char		srcpath[MAXPGPATH];
+	int			fd, i;
+	compressedpagemap_t *compressedpagemap = first_compressedpagemap;
+
+	/* open source compressed relation data file */
+	snprintf(srcpath, sizeof(srcpath), "%s/%s_pcd", datadir_source, path);
+
+	fd = open(srcpath, O_RDONLY | PG_BINARY, 0);
+	if (fd < 0)
+		pg_fatal("could not open source file \"%s\": %m",
+				srcpath);
+
+	/* copy blocks from source to target */
+	open_target_compressed_relation(path);
+
+	for(i=0; i < nblocks; i++)
+	{
+		int			j;
+		BlockNumber	blkno = blocknum + i;
+
+		while(compressedpagemap != NULL)
+		{
+			if(compressedpagemap->blkno == blkno)
+				break;
+			compressedpagemap = compressedpagemap->next;
+		}
+
+		if(compressedpagemap == NULL || compressedpagemap->blkno != blkno)
+			pg_fatal("could not find compressedpagemap for block %d of file \"%s\"",
+					 blkno, path);
+
+		for(j=0; j < compressedpagemap->nchunks; j++)
+		{
+			int		readlen;
+			int		seekpos;
+			int		length = chunk_size;
+			int		chunkindex = j;
+			pc_chunk_number_t	chunkno = compressedpagemap->chunknos[j];
+
+			seekpos = OffsetOfPageCompressChunk(chunk_size, chunkno);
+
+			while(j + 1 < compressedpagemap->nchunks && 
+			   compressedpagemap->chunknos[j + 1]== compressedpagemap->chunknos[j] + 1)
+			{
+				length += chunk_size;
+				j++;
+			}
+
+			if (lseek(fd, seekpos, SEEK_SET) == -1)
+				pg_fatal("could not seek in source file: %m");
+
+			readlen = read(fd, buf.data, length);
+			if (readlen != length)
+			{
+				if (readlen < 0)
+					pg_fatal("could not read file \"%s\": %m", srcpath);
+				else
+					pg_fatal("could not read file \"%s\": read %d of %zu", 
+							srcpath, readlen, (Size) length);
+			}
+
+			write_target_compressed_relation_chunk(buf.data, readlen, blkno, chunkindex,
+												   compressedpagemap->nchunks, prealloc_chunks);
+		}
+	}
+
+	if (close(fd) != 0)
+		pg_fatal("could not close file \"%s\": %m", srcpath);
+}
+
+
 /*
  * Copy all relation data files from datadir_source to datadir_target, which
  * are marked in the given data page map.
@@ -209,8 +361,15 @@ copy_executeFileMap(filemap_t *map)
 
 	for (i = 0; i < map->narray; i++)
 	{
+		bool	iscompressedrel = false;
+
 		entry = map->array[i];
-		execute_pagemap(&entry->pagemap, entry->path);
+
+		if(entry->type == FILE_TYPE_COMPRESSED_REL)
+			iscompressedrel = true;
+
+		execute_pagemap(&entry->pagemap, entry->path, iscompressedrel, entry->chunk_size,
+					    entry->prealloc_chunks, entry->first_compressedpagemap);
 
 		switch (entry->action)
 		{
@@ -223,12 +382,23 @@ copy_executeFileMap(filemap_t *map)
 				break;
 
 			case FILE_ACTION_TRUNCATE:
-				truncate_target_file(entry->path, entry->newsize);
+				if(iscompressedrel)
+					truncate_target_compressed_relation(entry->path, entry->newblocks);
+				else
+					truncate_target_file(entry->path, entry->newsize);
 				break;
 
 			case FILE_ACTION_COPY_TAIL:
-				rewind_copy_file_range(entry->path, entry->oldsize,
-									   entry->newsize, false);
+				if(iscompressedrel)
+					rewind_copy_compressed_relation_range(entry->path,
+														  entry->chunk_size,
+														  entry->oldblocks,
+														  entry->newblocks - entry->oldblocks,
+														  entry->prealloc_chunks,
+														  entry->first_compressedpagemap);
+				else
+					rewind_copy_file_range(entry->path, entry->oldsize,
+										entry->newsize, false);
 				break;
 
 			case FILE_ACTION_CREATE:
@@ -245,7 +415,9 @@ copy_executeFileMap(filemap_t *map)
 }
 
 static void
-execute_pagemap(datapagemap_t *pagemap, const char *path)
+execute_pagemap(datapagemap_t *pagemap, const char *path,
+				bool iscompressedrel, int chunk_size,
+				int prealloc_chunks, compressedpagemap_t *first_compressedpagemap)
 {
 	datapagemap_iterator_t *iter;
 	BlockNumber blkno;
@@ -254,8 +426,14 @@ execute_pagemap(datapagemap_t *pagemap, const char *path)
 	iter = datapagemap_iterate(pagemap);
 	while (datapagemap_next(iter, &blkno))
 	{
-		offset = blkno * BLCKSZ;
-		rewind_copy_file_range(path, offset, offset + BLCKSZ, false);
+		if(iscompressedrel)
+			rewind_copy_compressed_relation_range(path, chunk_size, blkno, 1,
+												  prealloc_chunks, first_compressedpagemap);
+		else
+		{
+			offset = blkno * BLCKSZ;
+			rewind_copy_file_range(path, offset, offset + BLCKSZ, false);
+		}
 		/* Ok, this block has now been copied from new data dir to old */
 	}
 	pg_free(iter);
diff --git a/src/bin/pg_rewind/fetch.c b/src/bin/pg_rewind/fetch.c
index f18fe5386e..f66bc2b31c 100644
--- a/src/bin/pg_rewind/fetch.c
+++ b/src/bin/pg_rewind/fetch.c
@@ -33,6 +33,15 @@ fetchSourceFileList(void)
 		libpqProcessFileList();
 }
 
+void
+fetchCompressedRelationAddress()
+{
+	if (datadir_source)
+		local_fetchCompressedRelationAddress(filemap);
+	else
+		libpq_fetchCompressedRelationAddress(filemap);
+}
+
 /*
  * Fetch all relation data files that are marked in the given data page map.
  */
diff --git a/src/bin/pg_rewind/fetch.h b/src/bin/pg_rewind/fetch.h
index 7cf8b6ea09..cdecdae917 100644
--- a/src/bin/pg_rewind/fetch.h
+++ b/src/bin/pg_rewind/fetch.h
@@ -18,27 +18,32 @@
 #include "access/xlogdefs.h"
 
 #include "filemap.h"
+#include "storage/page_compression.h"
 
 /*
  * Common interface. Calls the copy or libpq method depending on global
  * config options.
  */
 extern void fetchSourceFileList(void);
+extern void fetchCompressedRelationAddress(void);
 extern char *fetchFile(const char *filename, size_t *filesize);
 extern void executeFileMap(void);
 
 /* in libpq_fetch.c */
 extern void libpqProcessFileList(void);
 extern char *libpqGetFile(const char *filename, size_t *filesize);
+extern void libpq_fetchCompressedRelationAddress(filemap_t *map);
 extern void libpq_executeFileMap(filemap_t *map);
 
 extern void libpqConnect(const char *connstr);
 extern XLogRecPtr libpqGetCurrentXlogInsertLocation(void);
 
 /* in copy_fetch.c */
+extern void local_fetchCompressedRelationAddress(filemap_t *map);
 extern void copy_executeFileMap(filemap_t *map);
 
-typedef void (*process_file_callback_t) (const char *path, file_type_t type, size_t size, const char *link_target);
+typedef void (*process_file_callback_t) (const char *path, file_type_t type, size_t size, const char *link_target,
+                                         const PageCompressHeader *pchdr);
 extern void traverse_datadir(const char *datadir, process_file_callback_t callback);
 
 #endif							/* FETCH_H */
diff --git a/src/bin/pg_rewind/file_ops.c b/src/bin/pg_rewind/file_ops.c
index b3bf091c54..28de652409 100644
--- a/src/bin/pg_rewind/file_ops.c
+++ b/src/bin/pg_rewind/file_ops.c
@@ -22,12 +22,17 @@
 #include "file_ops.h"
 #include "filemap.h"
 #include "pg_rewind.h"
+#include "storage/page_compression.h"
+#include "storage/page_compression_impl.h"
 
 /*
  * Currently open target file.
  */
 static int	dstfd = -1;
 static char dstpath[MAXPGPATH] = "";
+static PageCompressHeader	*dstpcmap = NULL;
+static char dstpcapath[MAXPGPATH] = "";
+static int	chunk_size = 0;
 
 static void create_target_dir(const char *path);
 static void remove_target_dir(const char *path);
@@ -77,6 +82,14 @@ close_target_file(void)
 				 dstpath);
 
 	dstfd = -1;
+
+	if(dstpcmap != NULL)
+	{
+		if (pc_munmap(dstpcmap) != 0)
+			pg_fatal("could not munmap file \"%s\": %m", dstpcapath);
+
+		dstpcmap = NULL;
+	}
 }
 
 void
@@ -139,6 +152,10 @@ remove_target(file_entry_t *entry)
 		case FILE_TYPE_SYMLINK:
 			remove_target_symlink(entry->path);
 			break;
+		case FILE_TYPE_COMPRESSED_REL:
+			/* can't happen. */
+			pg_fatal("invalid action (REMOVE) for compressed relation file");
+			break;
 	}
 }
 
@@ -158,6 +175,7 @@ create_target(file_entry_t *entry)
 			break;
 
 		case FILE_TYPE_REGULAR:
+		case FILE_TYPE_COMPRESSED_REL:
 			/* can't happen. Regular files are created with open_target_file. */
 			pg_fatal("invalid action (CREATE) for regular file");
 			break;
@@ -323,3 +341,189 @@ slurpFile(const char *datadir, const char *path, size_t *filesize)
 		*filesize = len;
 	return buffer;
 }
+
+
+/*
+ * Open a target compressed relation for writing. If 'trunc' is true and the
+ * file already exists, it will be truncated.
+ */
+void
+open_target_compressed_relation(const char *path)
+{
+	char		localpath[MAXPGPATH];
+	int			mode;
+	int			fd, ret;
+	PageCompressHeader	pchdr;
+
+	if (dry_run)
+		return;
+
+	snprintf(localpath, sizeof(localpath), "%s/%s_pcd", datadir_target, path);
+
+	if (dstfd != -1 &&
+		strcmp(localpath, dstpath) == 0)
+		return;					/* already open */
+
+	close_target_file();
+
+	/* read page compression file header of target relation */
+	snprintf(dstpcapath, sizeof(dstpcapath), "%s/%s_pca", datadir_target, path);
+
+	fd = open(dstpcapath, O_RDWR | PG_BINARY, 0);
+	if (fd < 0)
+		pg_fatal("could not open target file \"%s\": %m",
+				 dstpcapath);
+
+	ret = read(fd, &pchdr, sizeof(PageCompressHeader));
+	if(ret != sizeof(PageCompressHeader))
+		pg_fatal("could not read compressed page address file \"%s\"",
+				 dstpcapath);
+
+	dstpcmap = pc_mmap(fd, pchdr.chunk_size, false);
+	if(dstpcmap == MAP_FAILED)
+		pg_fatal("Failed to mmap page compression address file %s: %m",
+				dstpcapath);
+
+	if (close(fd) != 0)
+		pg_fatal("could not close file \"%s\": %m", dstpcapath);
+
+	/* open page compression data file */
+	snprintf(dstpath, sizeof(dstpath), "%s/%s_pcd", datadir_target, path);
+
+	mode = O_WRONLY | O_CREAT | PG_BINARY;
+	dstfd = open(dstpath, mode, pg_file_create_mode);
+	if (dstfd < 0)
+		pg_fatal("could not open target file \"%s\": %m",
+				 dstpath);
+
+	chunk_size = pchdr.chunk_size;
+}
+
+
+void
+truncate_target_compressed_relation(const char *path, int newblocks)
+{
+	char				dstpath[MAXPGPATH];
+	int					fd, ret;
+	PageCompressHeader	pchdr, *dstpcmap;
+
+	if (dry_run)
+		return;
+
+	/* read page compression file header of target relation */
+	snprintf(dstpath, sizeof(dstpath), "%s/%s_pca", datadir_target, path);
+
+	fd = open(dstpath, O_RDWR | PG_BINARY, pg_file_create_mode);
+	if (fd < 0)
+		pg_fatal("could not open target file \"%s\": %m",
+				 dstpath);
+
+	ret = read(fd, &pchdr, sizeof(PageCompressHeader));
+	if(ret != sizeof(PageCompressHeader))
+		pg_fatal("could not read compressed page address file \"%s\"",
+				 dstpath);
+
+	dstpcmap = pc_mmap(fd, pchdr.chunk_size, false);
+	if(dstpcmap == MAP_FAILED)
+		pg_fatal("Failed to mmap page compression address file %s: %m",
+				dstpath);
+
+	if (close(fd) != 0)
+		pg_fatal("could not close file \"%s\": %m", dstpcapath);
+
+	/* resize target relation */
+	if(dstpcmap->nblocks > newblocks)
+	{
+		int blk;
+		for(blk = newblocks; blk < dstpcmap->nblocks; blk++)
+		{
+			PageCompressAddr *pcAddr = GetPageCompressAddr(dstpcmap, pchdr.chunk_size, blk);
+			pcAddr->nchunks = 0;
+		}
+		dstpcmap->nblocks = newblocks;
+	}
+
+	if (pc_munmap(dstpcmap) != 0)
+		pg_fatal("could not munmap file \"%s\": %m", dstpath);
+}
+
+
+void
+write_target_compressed_relation_chunk(char *buf, size_t size, int blocknum, int chunkindex, int nchunks, int prealloc_chunks)
+{
+	PageCompressAddr	*pcAddr;
+	int					i;
+	int		writeleft;
+	int		writed = 0;
+	char	*p = buf;
+	int		seekpos;
+	int		allocated_chunks = nchunks;
+
+	/* update progress report */
+	fetch_done += size;
+	progress_report(false);
+
+	if (dry_run)
+		return;
+
+	if(size <= 0)
+		return;
+
+	pcAddr = GetPageCompressAddr(dstpcmap, chunk_size, blocknum);
+
+	/* allocate chunks */
+	if(allocated_chunks < prealloc_chunks)
+		allocated_chunks = prealloc_chunks;
+
+	if(pcAddr->allocated_chunks < allocated_chunks)
+	{
+		for(i = pcAddr->allocated_chunks; i< allocated_chunks; i++)
+		{
+			pcAddr->chunknos[i] = dstpcmap->allocated_chunks + 1;
+			dstpcmap->allocated_chunks++;
+		}
+		pcAddr->allocated_chunks = allocated_chunks;
+	}
+
+	if(dstpcmap->nblocks <= blocknum)
+		dstpcmap->nblocks = blocknum + 1;
+	
+	if(pcAddr->nchunks != nchunks)
+		pcAddr->nchunks = nchunks;
+
+	while(writed < size)
+	{
+		/* write one chunk to target */
+
+		writeleft = size - writed;
+		if(writeleft > chunk_size)
+			writeleft = chunk_size;
+
+		seekpos = OffsetOfPageCompressChunk(chunk_size, pcAddr->chunknos[chunkindex + writed / chunk_size]);
+
+		if (lseek(dstfd, seekpos, SEEK_SET) == -1)
+			pg_fatal("could not seek in target file \"%s\": %m",
+						dstpath);
+
+		while (writeleft > 0)
+		{
+			int			writelen;
+
+			errno = 0;
+			writelen = write(dstfd, p, writeleft);
+			if (writelen < 0)
+			{
+				/* if write didn't set errno, assume problem is no disk space */
+				if (errno == 0)
+					errno = ENOSPC;
+				pg_fatal("could not write file \"%s\": %m",
+						dstpath);
+			}
+
+			p += writelen;
+			writeleft -= writelen;
+			writed += writelen;
+		}
+	}
+	/* keep the file open, in case we need to copy more blocks in it */
+}
diff --git a/src/bin/pg_rewind/file_ops.h b/src/bin/pg_rewind/file_ops.h
index 025f24141c..31e2d7a058 100644
--- a/src/bin/pg_rewind/file_ops.h
+++ b/src/bin/pg_rewind/file_ops.h
@@ -22,4 +22,9 @@ extern void remove_target(file_entry_t *t);
 
 extern char *slurpFile(const char *datadir, const char *path, size_t *filesize);
 
+extern void open_target_compressed_relation(const char *path);
+extern void write_target_compressed_relation_chunk(char *buf, size_t size, int blocknum, int chunkindex,
+                                                    int nchunks, int prealloc_chunks);
+extern void truncate_target_compressed_relation(const char *path, int newblocks);
+
 #endif							/* FILE_OPS_H */
